<?php
include_once(dirname(__FILE__).'/ChatRequestRemote.php');
define('CACHE_PATH', dirname(dirname(dirname(dirname(__FILE__)))) . '/ow_smarty/template_c/');
class FLASHCHAT_CLASS_Flashchat
{
    private $actions;
    private static $classInstance;
    
	public function __construct() { }
	
	public static function getInstance(){
        if ( null === self::$classInstance ){
            self::$classInstance = new self();
        }
        return self::$classInstance;
    }

    public function getChatUrl( $setting, $adminpanel = false ){
    	$url = '';
    	$userurl = '';
    	if(!empty($_SESSION['userId'])){
    		$user = FLASHCHAT_BOL_UserDao::getInstance()->getUserById($_SESSION['userId']);
    		if(!empty($user->id)){
    			if($setting->extendserver == 2){
    				$userurl = '&user=' . $user->username;
    			}else{
    				$userurl = '&init_user=' . $user->username . '&init_password=' . $user->password;
    			}
    		}
    	}
    	switch ($setting->extendserver){
    		case 0 :
				if($adminpanel){
					$clientname = 'admin_123flashchat.swf';
				}else{
					if($setting->servertype != 1 && $setting->clienttype == 1){
						$clientname = '123flashchat.swf';
					}else{
						$clientname = 'htmlchat/123flashchat.html';
					}
				}
	            $url = $setting->client_loc . $clientname . '?init_host=' . $setting->server_host . '&init_port=' . $setting->server_port;
				$url .= (!empty($setting->server_host_s) ? '&init_host_s=' . $setting->server_host_s : '') . (!empty($setting->server_port_s) ? '&init_port_s=' . $setting->server_port_s : '');
				$url .= (!empty($setting->server_host_h) ? '&init_host_h=' . $setting->server_host_h : '') . (!empty($setting->server_port_h) ? '&init_port_h=' . $setting->server_port_h : '');
				break;
    		case 1 :
				if($adminpanel){
					$clientname = 'admin_123flashchat.swf';
				}else{
					if($setting->clienttype == 1){
						$clientname = '123flashchat.swf';
					}else{
						$clientname = 'htmlchat/123flashchat.html';
					}
				}
				$url = $setting->client_loc . $clientname . '?init_host=' . $setting->server_host . '&init_port=' . $setting->server_port;
				$url .= (!empty($setting->server_host_s) ? '&init_host_s=' . $setting->server_host_s : '') . (!empty($setting->server_port_s) ? '&init_port_s=' . $setting->server_port_s : '');
				$url .= (!empty($setting->server_host_h) ? '&init_host_h=' . $setting->server_host_h : '') . (!empty($setting->server_port_h) ? '&init_port_h=' . $setting->server_port_h : '');
	            $url .= '&init_group=' . $setting->group;
    			break;
    		case 2 :
    		default:
	    		$url = 'http://free.123flashchat.com/js.php?room=' . $setting->room . '&skin=' . $setting->client_skin .'&lang=' . $setting->client_lang;
    			break;    		
    	}
    	if(!empty($_GET['room'])){
    		$url .= '&init_room='.$_GET['room'];
    	}
    	if(!empty($_GET['listroom'])){
    		$url .= '&init_listroom='.$_GET['listroom'];
    	}
    	return $url . $userurl;
    }
    
    public function getValid($fcSetting){
    	$c_server_loc = 1;
		if($fcSetting->server_host){
			if($fcSetting->server_host == $_SERVER['SERVER_NAME']){
				$c_own_loc = $this->validate_client('http://'.$fcSetting->server_host.':'.$fcSetting->server_port_h.'/');
				if(!$c_own_loc){
					$c_server_loc = 0;
				}
			}
		}else{
			$c_own_loc = $this->validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$fcSetting->server_port_h.'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
		return $c_server_loc;
    }
    
    public function validate_client($client_loc){
    	$c_own_loc = 1;
		$swf = $client_loc . 'admin_123flashchat.swf';
		if($headers = topcmmRequestRemote::requestRemote($swf,0)){
			$c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
		}
		return $c_own_loc;
    }
    
    public function validate_data_api($data_api){
		$da = 1;
		if(substr(topcmmRequestRemote::requestRemote($data_api,0), 9, 3) == 200){
			$da = 0;
		}
		return $da;
	}

	public function getStatus(){
		$chatsetting = FLASHCHAT_BOL_FlashchatDao::getInstance()->getSettings();
		$data = topcmmRequestRemote::requestRemote(CACHE_PATH."status.js",1);
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json){
	        $server =  $chatsetting->extendserver;
	        switch ($server){
	            case 0:
	        	    $status_js = $chatsetting->api_url . "online.js";
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 1:
	        	    $status_js = $chatsetting->api_url . "online.js?group=" . $chatsetting->group;
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 2:
	        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $chatsetting->room;
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	        	        $status['ln'] = $matches[1];					
	        	        $status['rn'] = '';
	        	        $status['cn'] = '';
	        	        $status_json = json_encode($status);
	        	    }
	        	    break;
	        }
			@file_put_contents(CACHE_PATH."status.js",(time() + 120) . $status_json);
	    }
		return json_decode($status_json,true);
	}
	
	public function getRooms(){
		$opts = array('http'=>array('timeout'=>3,));
		$context = stream_context_create($opts); 
        $chatsetting = FLASHCHAT_BOL_FlashchatDao::getInstance()->getSettings();
        $data = topcmmRequestRemote::requestRemote(CACHE_PATH."rooms.js",1);
		$rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json){
	    	$server =  $chatsetting->extendserver;
	        switch ($server) {
	            case 0:
	        	    $room_js = $chatsetting->api_url . "rooms.js";
	        	    break;
	            case 1:
	        	    $room_js = $chatsetting->api_url . "rooms.js?group=" . $chatsetting->group;
	        	    break;
	            case 2:
	            	break;
	        }
	        if($rs = topcmmRequestRemote::requestRemote($room_js, 1)){
	        	$rooms_json = substr($rs,10,-1);
	        }
	        @file_put_contents(CACHE_PATH."rooms.js",(time() + 120) . $rooms_json);
	    }
	    return json_decode($rooms_json, true);
	}	
	
	public function getUsers(){
		$opts = array('http'=>array('timeout'=>2,));
		$context = stream_context_create($opts); 
        $chatsetting = FLASHCHAT_BOL_FlashchatDao::getInstance()->getSettings();
		$data =  topcmmRequestRemote::requestRemote(CACHE_PATH."users.js",1);
		$users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json){
	    	$server =  $chatsetting->extendserver;
	        switch ($server){
	            case 0:
	                $rooms = self::getRooms();
	                if ($rooms == null){
	                	return null;
	                }
	                $users = array();
	                foreach ($rooms as $room){
	                    $user_js = $chatsetting->api_url . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
	                $users_json = json_encode($users);
	        	    break;
	            case 1:
	        	    $user_js = $chatsetting->api_url . "roomonlineusers.js?group=" . $chatsetting->group;
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	        	        $users_json = substr($rs,20,-1);
	        	    }
	        	    break;
	        	case 2:
	        		$users = array();       		
	        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $chatsetting->room;
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	    	            foreach (explode(',', $matches[1]) as $user){
	    	                $users[] = array('name' => $user);
	    	            }
	    	        }
	    	        $users_json = json_encode($users);
	    	        break;
	        }
	        $users_json = self::filterUserList($users_json);
	        @file_put_contents(CACHE_PATH."users.js",(time() + 120) . $users_json);
	    }
	    return json_decode($users_json, true);
	}
	
	private function filterUserList($users_json){
		$user_array =  json_decode($users_json,true);
		$user_regroup_array = array();
		$user_tmp_array = array();
		foreach($user_array as $key => $val){
			if (!in_array($val['name'], $user_tmp_array)){
				$user_tmp_array[] = $val['name'];
				$user_regroup_array[$key] = $user_array[$key];
			}
		}
		return json_encode($user_regroup_array);
	}
	
}