<?php
class FLASHCHAT_BOL_UserDao extends OW_BaseDao
{
	private static $classInstance;
	
	protected function __construct(){
        parent::__construct();
    }
    
	/**
     * Returns class instance
     *
     * @return FLASHCHAT_BOL_Clip
     */
    public static function getInstance(){
        if ( null === self::$classInstance ){
            self::$classInstance = new self();
        }
        return self::$classInstance;
    }
    
    public function getUserById($userId){
    	$query = "SELECT * FROM `" . $this->getTableName() . "` WHERE id = $userId";
		return $this->dbo->queryForObject($query, $this->getDtoClassName());
    }
    
	public function getUserByName($userName){
    	$query = "SELECT * FROM `" . $this->getTableName() . "` WHERE username = '$userName'";
		return $this->dbo->queryForObject($query, $this->getDtoClassName());
    }
    
	public function getUserPhotoHashById($userId){
    	$query = "SELECT * FROM `" . $this->getAvatarTableName() . "` WHERE userID = $userId";
		return $this->dbo->queryForObject($query, $this->getDtoClassName());
    }
    
    public function getUserDataById($userId){
    	$query = "SELECT * FROM `" . $this->getUserDataTableName() . "` WHERE userID = $userId";
		return $this->dbo->queryForObjectList($query, $this->getDtoClassName());
    }
        
	/**
     * @see OW_BaseDao::getDtoClassName()
     *
     * @return string
     */
    public function getDtoClassName(){
        return 'FLASHCHAT_BOL_Clip';
    }

    /**
     * @see OW_BaseDao::getTableName()
     *
     * @return string
     */
    public function getTableName(){
        return OW_DB_PREFIX . 'base_user';
    }
	public function getAvatarTableName(){
        return OW_DB_PREFIX . 'base_avatar';
    }
    
    public function getUserDataTableName(){
    	return OW_DB_PREFIX . 'base_question_data';
    }
}